/* 
 * noIdle header file v0.5
 * 
 * (C) 2002 - Jos Martins (jemart@student.dei.uc.pt)
 * 
 * */

#ifndef __NOIDLE_H__
#define __NOIDLE_H__

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <string.h>
#include <ctype.h>
#include <signal.h>
#include <errno.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/wait.h>

#define IDLE 0
#define NOIDLE 1
#define MAX_LINE 1024
#define CICLE_TIME 120 /* seconds (900seg=15min) */
#define IDLE_TIME 30 /* minutes */

#define CMD_W 0
#define CMD_PS 1
#define CMD_WHOAMI 3

#define LOG_FILE "noIdle.log"
#define LOG_PERM "a"

/* process information struct */
typedef struct my_process{
  char name[MAX_LINE];
  char tty[MAX_LINE];
  int pid;
  int idle;
}process;

/* 
 * Gets the curent process information.
 * */
int processCmd(int cmd, char *arg0, char *arg1);

/* 
 * Reads from pipe and place string in arg0.
 * */
int read_pipe_fd(char *arg0);

/* 
 * Checks if the string <str> (obtained from processStatus) has intormation
 * about a idle process.
 * */
int checkIdle(char *str);

/* 
 * Prints a message in the log file.
 * */
void printMsg(char *msg);

/* 
 * Signal catching...
 * */
int assignSignals(void);

/* 
 * Copy into <tok> the token number <tokNum> from string <str> since <offs>.
 * */
int getToken(int tokNum, char *tok, char *str, int *offs);

/* 
 * Catched function.
 * */
void panicExit(int signal);

#endif /* __NOIDLE_H__ */
